%global		momorel 7

Summary:        Tool to update x86/x86-64 CPU microcode
Name:           microcode_ctl
Version:        1.17
Release:	%{momorel}m%{?dist}
Group:          System Environment/Base
License:        GPLv2+
Source0:        microcode_ctl-%{version}.tar.gz
Source1:	microcode_ctl.init
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Prereq:		chkconfig initscripts
Requires:	grep gawk coreutils
Obsoletes:	kernel-utils
ExclusiveArch:	%{ix86} x86_64

# Microcode now distributed directly by Intel, at
# http://downloadcenter.intel.com (just search for microcode)
Source2:        microcode-20090330.dat.bz2
Patch1: microcode_ctl.patch

%description
microcode_ctl - updates the microcode on Intel x86/x86-64 CPU's

%prep
%setup -q
%patch1 -p1

%build
make CFLAGS="$RPM_OPT_FLAGS" %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} PREFIX=%{_prefix} \
     INSDIR=/sbin MANDIR=%{_mandir}/man8 RCDIR=%{_sysconfdir} install clean

install %{SOURCE1} %{buildroot}%{_sysconfdir}/init.d/microcode_ctl
mkdir -p %{buildroot}/lib/firmware
bzcat %{SOURCE2} > %{buildroot}/lib/firmware/microcode.dat
chmod 644 %{buildroot}/lib/firmware/microcode.dat

chmod -R a-s %{buildroot}

%clean
rm -rf --preserve-root %{buildroot};

%files
%defattr(-,root,root)
%{_sysconfdir}/init.d/microcode_ctl
/lib/firmware/*
/sbin/microcode_ctl
%attr(0644,root,root) %{_mandir}/*/*



%preun
if [ "$1" = "0" ] ; then
	/sbin/chkconfig --del microcode_ctl
fi

%post
# Only enable on Intel 686's and above.
vendor=`cat /proc/cpuinfo | grep "^vendor_id" | sort -u | awk -F ": " '{ print $2 }'`
[ "$vendor" != "GenuineIntel" ] && exit 0
family=`cat /proc/cpuinfo | grep "^cpu family" | sort -u | awk -F ": " '{ print $2 }'`
[ $family -lt 6 ] && exit 0
/sbin/chkconfig --add microcode_ctl

%triggerpostun -- kernel-utils
# Only enable on Intel 686's and above.
vendor=`cat /proc/cpuinfo | grep "^vendor_id" | sort -u | awk -F ": " '{ print $2 }'`
[ "$vendor" != "GenuineIntel" ] && exit 0
family=`cat /proc/cpuinfo | grep "^cpu family" | sort -u | awk -F ": " '{ print $2 }'`
[ $family -lt 6 ] && exit 0
/sbin/chkconfig --add microcode_ctl
exit 0

%changelog
* Fri Jun  5 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.17-7m)
- update microcode to 20090330
- merge some changes from fedora
-- now microcode.dat is placed into /lib/firmware/

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.17-6m)
- rebuild against rpm-4.6

* Mon Jan 12 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.17-5m)
- %%global _default_patch_fuzz 2
- License: GPLv2+

* Mon Sep 15 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.17-4m)
- update microcode to 20080910

* Fri Sep  5 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.17-3m)
- update microcode to 20080401

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.17-2m)
- rebuild against gcc43

* Tue Jul  3 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.17-1m)
- update to 1.17

* Tue Jun  6 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.13-1m)
- update to 1.13

* Sat May 20 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.12-1m)
- import from fc

* Fri Dec 16 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcj

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Mon Nov 14 2005 Dave Jones <davej@redhat.com>
- initscript tweaks.

* Tue Sep 13 2005 Dave Jones <davej@redhat.com>
- Update to upstream 1.12

* Wed Aug 17 2005 Dave Jones <davej@redhat.com>
- Check for device node *after* loading the module. (#157672)

* Tue Mar  1 2005 Dave Jones <davej@redhat.com>
- Rebuild for gcc4

* Thu Feb 17 2005 Dave Jones <davej@redhat.com>
- s/Serial/Epoch/

* Tue Jan 25 2005 Dave Jones <davej@redhat.com>
- Drop the node creation/deletion change from previous release.
  It'll cause grief with selinux, and was a hack to get around
  a udev shortcoming that should be fixed properly.

* Fri Jan 21 2005 Dave Jones <davej@redhat.com>
- Create/remove the /dev/cpu/microcode dev node as needed.
- Use correct path again for the microcode.dat.
- Remove some no longer needed tests in the init script.

* Fri Jan 14 2005 Dave Jones <davej@redhat.com>
- Only enable microcode_ctl service if the CPU is capable.
- Prevent microcode_ctl getting restarted multiple times on initlevel change (#141581)
- Make restart/reload work properly
- Do nothing if not started by root.

* Wed Jan 12 2005 Dave Jones <davej@redhat.com>
- Adjust dev node location. (#144963)

* Tue Jan 11 2005 Dave Jones <davej@redhat.com>
- Load/Remove microcode module in initscript.

* Mon Jan 10 2005 Dave Jones <davej@redhat.com>
- Update to upstream 1.11 release.

* Sat Dec 18 2004 Dave Jones <davej@redhat.com>
- Initial packaging, based upon kernel-utils.

